/* =========================================================== */
/*     version 1.0       June 11 1999  wilko                   */
/* =========================================================== */



#include <stdio.h>


//
//   National intstrument PCI VME interface boards
//

#define   VXINT
#include  "nivxi.h"

#include "messages.h"

extern int verb_flag;

uint16* initVme(unsigned long);



void main ()
{


	uint16* address_map;
	address_map = initVme (0x80000);  // vme base address of dsp
	set_ioBase ( address_map );


	/* --------------------------------------- 	*/
	/*   allocate memory for the message base   */
	/* --------------------------------------- 	*/

	if ( !memoryMessageBase (0x20000) )  {
		printf("  no memory base \n");
		return;
	}


	/* ----------------------------- */
	/*   Init the DSP System Code    */
	/* ----------------------------- */
  	 	
  	 	
	send_sys_ech (0, 0, "sys_main.asc");   // load dsp code



	verbose_flag_off ();
	
	/* -------------------------------------- */
	/*    initilieze  links */
	/* -------------------------------------- */

	do_set_counter_val (100);

	
	do_enable_readout (0);
	
	do_dis_enable_link (0, 0, 1);
	do_dis_enable_link (0, 1, 0);
	do_dis_enable_link (0, 2, 0);
	do_dis_enable_link (0, 3, 0);


	/* ---------------------------- */
	/*    load bit pattern          */
	/* ---------------------------- */
	
	do_read_controlBlock_file (0, "test.cb"); 

	do_execute_control_block (0, 50);


	do_calibrate (10, 1, 0);
	do_dataTransfer (0, 0, 2);

}



uint16* initVme (unsigned long address)
{
	int      stat;
	int16    ret;	
	int32    timo = 0L;
	uint16*  baseAddr;

	unsigned long     vmeWindow;
		

	stat = InitVXIlibrary ();
	printf ("  VXI lib open:  \n");

	if (  stat != 0 ) return 0;
	
	baseAddr = (uint16 *) MapVXIAddress (2, address, timo, &vmeWindow, &ret);


	if ( baseAddr <= 0 )  {
		return 0;
	}
	else {
		return baseAddr;
	}
}